//
//  TKMDManagedObject.m
//  ThemeKit
//
//  Created by Colin Cornaby on 4/19/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import "TKMDManagedObject.h"


@implementation TKMDManagedObject

-(void)setMetadataForKey:(id)key forValue:(id)value
{
	NSManagedObject *metadataObject = [self valueForKey:@"metadata"];
	if(metadataObject==nil)
	{
		metadataObject = [NSEntityDescription insertNewObjectForEntityForName:@"TKResourceMetadata" inManagedObjectContext:[self managedObjectContext]];
		[self setValue:metadataObject forKey:@"metadata"];
	}
	NSMutableDictionary *metadataDict = [NSMutableDictionary dictionaryWithDictionary:[[[self valueForKey:@"metadata"] valueForKey:@"metadata"] propertyList]];
	if(metadataDict==nil)
		metadataDict = [[[NSMutableDictionary alloc] init] autorelease];
	[metadataDict setObject:value forKey:key];
	NSString *myError = @"";
	NSData *plistData = [NSPropertyListSerialization dataFromPropertyList:metadataDict format:NSPropertyListXMLFormat_v1_0 errorDescription:&myError];
	NSString *metadataAsString = [[NSString alloc] initWithData:plistData encoding:NSUTF8StringEncoding];
	[[self valueForKey:@"metadata"] setValue:metadataAsString forKey:@"metadata"];
}

-(id)metadataForKey:(id)key
{
	return [[[[self valueForKey:@"metadata"] valueForKey:@"metadata"] propertyList] objectForKey:key];
}

@end
